{{
Sound driver for DE2-115 sound chip with the hardware controlled buffer
v.0.01 - 20140817
inb [1..0] - lower/upper half of the buffer is empty
dirb[7..0] - buffer address
dirb[8] - write strobe
outb[31..0] - sample data
}}


VAR

  long cog
  long buf[512]
  long bufnum


pub getbuf
return @buf

pub getbufnum
return @bufnum


PUB start

longfill(@buf,0,512)
bufptr:=@buf
bufnum:=0
stop

cog:=1+cognew(@init, @bufnum)
return cog


PUB stop

longfill(@buf,0,512)
if cog>0
  cogstop(cog-1)
cog := 0


DAT
                        org     0                         'initialization

init
                        mov     bufptr2,par

loop                    mov     a1,inb
                        and     a1,#1
                        cmp     a1,#1           wz
              if_nz     jmp     #loop                   ' lower half of the buffer is empty

                        mov     a2,#0


p101                    mov     ptr,bufptr               ' compute pointer to sample
                        add     ptr,bufcnt
                        rdlong  lsample,ptr
                        add     bufcnt,#4
                        and     bufcnt,bufmask
                        wrlong  bufcnt,bufptr2           ' write actual sample number for main program

                        mov     dirb,a2
                        mov     outb,lsample
                        or      dirb,#256
                        add     a2,#1
                        cmp     a2,#128         wz
              if_nz     jmp     #p101

p102                    mov     a1,inb
                        and     a1,#2
                        cmp     a1,#2           wz
              if_nz     jmp     #p102                    ' lower half of the buffer is empty

                        mov     a2,#0

p103                    mov     ptr,bufptr               ' compute pointer to sample
                        add     ptr,bufcnt
                        rdlong  lsample,ptr
                        add     bufcnt,#4
                        and     bufcnt,bufmask
                        wrlong  bufcnt,bufptr2           ' write actual sample number for main program

                        mov     a1,a2
                        add     a1,#128
                        mov     dirb,a1
                        mov     outb,lsample
                        or      dirb,#256
                        add     a2,#1
                        cmp     a2,#128         wz
              if_nz     jmp     #p103

                        jmp     #loop


bufmask                 long    %0000_0000_0000_0000_0000_0111_1111_1111
bufptr                  long    0
bufptr2                 long    0
bufcnt                  long    0

lsample                 res 1
ptr                     res 1
a1                      res 1
a2                      res 1

                        fit     496

{{

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}
